# Kubernetes optimization pack

The *Kubernetes* optimization pack allows optimizing containerized applications running on a Kubernetes cluster. Through this optimization pack, Akamas is able to tackle the problem of distributing resources to containerized applications in order to minimize waste and ensure the quality of service.

To achieve these goals the optimization pack provides parameters that focus on the following areas:

* Memory allocation
* CPU allocation
* Number of replicas

Similarly, the bundled metrics provide visibility on the following aspects of tuned applications:

* Memory utilization
* CPU utilization

## Component Types

The component types provided in this optimization pack allow modeling the entities found in a Kubernetes-based application, optimizing their parameters, and monitoring the key performance metrics.

| Component Type                                                                                                               | Description          |
| ---------------------------------------------------------------------------------------------------------------------------- | -------------------- |
| [Kubernetes Container](https://docs.akamas.io/akamas-docs/reference/optimization-packs/kubernetes-pack/kubernetes-container) | Kubernetes Container |
| [Kubernetes Pod](https://docs.akamas.io/akamas-docs/reference/optimization-packs/kubernetes-pack/kubernetes-pod)             | Kubernetes Pod       |
| [Kubernetes Workload](https://docs.akamas.io/akamas-docs/reference/optimization-packs/kubernetes-pack/kubernetes-workload)   | Kubernetes Workload  |
| [Kubernetes Namespace](https://docs.akamas.io/akamas-docs/reference/optimization-packs/kubernetes-pack/kubernetes-namespace) | Kubernetes Namespace |
| [Kubernetes Cluster](https://docs.akamas.io/akamas-docs/reference/optimization-packs/kubernetes-pack/kubernetes-cluster)     | Kubernetes Cluster   |

## Installing

Here’s the command to install the *Kubernetes* optimization pack optimization-pack using the Akamas CLI:

```bash
akamas install optimization-pack Kubernetes
```


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.akamas.io/akamas-docs/reference/optimization-packs/kubernetes-pack.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
